<?php
  include ('./accesscontrol.php');

  include ('./header_main.html');

  echo "</center>";

  require_once ('./my_functions.php');


  $my_error = "";

  // check if the form has been submitted
  if (isset($_POST['add_or_modify_an_entry']))
  {
    $cgi = safeEscapeString($_GET["am"]);               //this is '-99' if the user is adding a new name and '$id' if a user is modifying an existing name
    
    // get all variables from form - Person
    $name1 = safeEscapeString($_POST["name"]);

    $name1 = str_replace(" ", "_", $name1);
    $name1 = str_replace(chr(39), "~", $name1);
    
    $month1 = safeEscapeString($_POST["month"]);
    $day1 = safeEscapeString($_POST["day"]);
    $year1 = safeEscapeString($_POST["year"]);

    $hour1 = safeEscapeString($_POST["hour"]);
    $minute1 = safeEscapeString($_POST["minute"]);
    $amorpm1 = safeEscapeString($_POST["amorpm"]);

    $timezone1 = safeEscapeString($_POST["timezone"]);

    $long_deg1 = safeEscapeString($_POST["long_deg"]);
    $long_min1 = safeEscapeString($_POST["long_min"]);
    $ew1 = strtoupper(safeEscapeString($_POST["ew"]));

    $lat_deg1 = safeEscapeString($_POST["lat_deg"]);
    $lat_min1 = safeEscapeString($_POST["lat_min"]);
    $ns1 = strtoupper(safeEscapeString($_POST["ns"]));


    include("validation_class.php");


    //error check
    $my_form = new Validate_fields;

    $my_form->check_4html = true;

    $my_form->add_text_field("Name", $name1, "text", "y", 40);

    $my_form->add_text_field("Month", $month1, "text", "y", 2);
    $my_form->add_text_field("Day", $day1, "text", "y", 2);
    $my_form->add_text_field("Year", $year1, "text", "y", 4);

    $my_form->add_text_field("Hour", $hour1, "text", "y", 2);
    $my_form->add_text_field("Minute", $minute1, "text", "y", 2);

    $my_form->add_text_field("Time zone", $timezone1, "text", "y", 7);

    $my_form->add_text_field("Longitude degree", $long_deg1, "text", "y", 3);
    $my_form->add_text_field("Longitude minute", $long_min1, "text", "y", 2);
    $my_form->add_text_field("Longitude E/W", $ew1, "text", "y", 2);

    $my_form->add_text_field("Latitude degree", $lat_deg1, "text", "y", 2);
    $my_form->add_text_field("Latitude minute", $lat_min1, "text", "y", 2);
    $my_form->add_text_field("Latitude N/S", $ns1, "text", "y", 2);


    // additional error checks on user-entered data
    if (is_numeric($timezone1) == False) { $my_error .= "The time zone entry has to be a number, either positive or negative - it cannot be text.<br>"; }

    if ($month1 != "" And $day1 != "" And $year1 != "")
    {
      if (!$date = checkdate($month1, $day1, $year1)) { $my_error .= "The date of birth you entered is not valid.<br>"; }
    }

    if (($year1 < 1200) Or ($year1 >= 2400)) { $my_error .= "Birth year person - please enter a year between 1200 and 2399.<br>"; }

    if ((intval($hour1) < 1) Or (intval($hour1) > 12)) { $my_error .= "Birth hour must be between 1 and 12.<br>"; }

  if (is_numeric($hour1) == False) { $my_error .= "Birth hour must be a numeric value between 1 and 12.<br>"; }

    if ($minute1 < 0 Or $minute1 > 59) { $my_error .= "Birth minute must be between 0 and 59.<br>"; }

  if ($amorpm1 == "") { $my_error .= "Please tell me AM, PM, or birth time unknown.<br>"; }

  if (is_numeric($minute1) == False) { $my_error .= "Birth minute must be a numeric value between 0 and 59.<br>"; }

    if ($timezone1 < -13 Or $timezone1 > 13) { $my_error .= "Time zone must be between -13 and 13.<br>"; }

    if (($long_deg1 < 0) Or ($long_deg1 > 179)) { $my_error .= "Longitude degrees must be between 0 and 179.<br>"; }

    if (($long_min1 < 0) Or ($long_min1 > 59)) { $my_error .= "Longitude minutes must be between 0 and 59.<br>"; }

    if (($lat_deg1 < 0) Or ($lat_deg1 > 65)) { $my_error .= "Latitude degrees must be between 0 and 65.<br>"; }

    if (($lat_min1 < 0) Or ($lat_min1 > 59)) { $my_error .= "Latitude minutes must be between 0 and 59.<br>"; }

    if (($ew1 == 'W') And ($timezone1 < -2)) { $my_error .= "You have marked West longitude but set an east time zone.<br>";     }

    if (($ew1 == 'E') And ($timezone1 > 1)) { $my_error .= "You have marked East longitude but set a west time zone.<br>"; }

    if ($ew1 != 'E' And $ew1 != 'W') { $my_error .= "Longitude must be either E or W.<br>"; }

    if ($ns1 != 'N' And $ns1 != 'S') { $my_error .= "Latitude must be either N or S.<br>"; }

  if (is_numeric($long_deg1) == False) { $my_error .= "Longitude degrees must be a numeric value between 0 and 180.<br>"; }
  
  if (is_numeric($long_min1) == False) { $my_error .= "Longitude minutes must be a numeric value between 0 and 59.<br>"; }

  if (is_numeric($lat_deg1) == False) { $my_error .= "Latitude degrees must be a numeric value between 0 and 66.<br>"; }
  
  if (is_numeric($lat_min1) == False) { $my_error .= "Latitude minutes must be a numeric value between 0 and 59.<br>"; }


    $validation_error = $my_form->validation();

    if ((!$validation_error) || ($my_error != ""))
    {
      echo "<div id='content'>";
      echo "<h1>AstroWin </h1>";

      $error = $my_form->create_msg();
      echo "<strong>Error! - The following error(s) occurred:</font><br>";

      if ($error)
      {
        echo $error . $my_error;
      }
      else
      {
        echo $error . "<br>" . $my_error;
      }

      echo "</strong>";
      echo "<p>&nbsp;</p>";
      echo "</div>";

      include ('./footer_main.html');
      exit();
    }
    else
    {
      // no errors in filling out form, so process form
      //insert this information into the current .fil file
      $east_west = -1;
      if ($ew1 == "W") { $east_west = 1; }

      $north_south = 1;
      if ($ns1 == "S") { $north_south = -1; }

      $months2 = array (0 => 'Choose month', 'Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec');

      $t = $name1 . "," . sprintf("%02d", $day1) . " " . $months2[$month1] . " " . $year1 . ",";
      
      $t .= $hour1 . "." . $minute1 . "," . substr($amorpm1, 0, 1) . "," . $timezone1 . ",";
      
      $t .= $east_west * $long_deg1 . "." . sprintf("%02d", $long_min1) . ",";
      
      $t .= $north_south * $lat_deg1 . "." . sprintf("%02d", $lat_min1) . "\n";
      
      if ($cgi == -99)
      {
        //add a new name
        $fh = fopen("./data_files/" . $_SESSION['current_selected_fil_file'], "a");

        $fout = fwrite($fh, $t);
      }
      else
      {
        //modify an existing name - $cgi is the ID number of the person
        //read in the contents of the selected .fil file into an array()
        $line_fil_array = file("./data_files/" . $_SESSION['current_selected_fil_file']);

        //update this user's record
        $line_fil_array[$cgi] = $t;

        $fh = fopen("./data_files/" . $_SESSION['current_selected_fil_file'], "w");

        for ($x = 0; $x <= count($line_fil_array) - 1; $x++)
        {
          $fout = fwrite($fh, $line_fil_array[$x]);
        }
      }

      fclose($fh);
      
      //read in the contents of the selected .fil file into an array()
      $line_fil_array = file("./data_files/" . $_SESSION['current_selected_fil_file']);

      $_SESSION['everyones_natal_data'] = $line_fil_array;

      echo "<meta HTTP-EQUIV='REFRESH' content='0; url=./index.php'>";
    }
  }
?>
