<?php
  include ('./accesscontrol.php');
  include ('./get_birth_data.php');    //see comments on $birth_data_array[] array in this file

  $no_interps = False;        //set this to False when you want interpretations

  include ('header_dual_c.html');

  echo "<center>";

  // connect to and point to the proper database
  require ('dual_c_calcs.php');
  require ('dual_c_mrs.php');
  require ('dual_c_display_natal_data.php');
  require ('dual_c_display_results.php');

  // get ID1 and ID2
  $id[1] = safeEscapeString($_POST["id1"]);
  $id[2] = safeEscapeString($_POST["id2"]);

  //take $id[1] and $id[2] passed to us & fetch all birth data needed from $_SESSION['everyones_natal_data']
  Get_proper_birth_data($id[1], $id[2], $birth_data_array);

  if ($birth_data_array[1][0] == "")
  {
    echo "<center><br><br>I cannot find person #1 in the database. Please try again.</center>";
    include ('footer.html');
    exit();
  }

  if ($birth_data_array[2][0] == "")
  {
    echo "<center><br><br>I cannot find person #2 in the database. Please try again.</center>";
    include ('footer.html');
    exit();
  }


  // assign data from database into arrays for display
  $pl_name1[0] = "Sun";
  $pl_name1[1] = "Moon";
  $pl_name1[2] = "Mercury";
  $pl_name1[3] = "Venus";
  $pl_name1[4] = "Mars";
  $pl_name1[5] = "Jupiter";
  $pl_name1[6] = "Saturn";
  $pl_name1[7] = "Uranus";
  $pl_name1[8] = "Neptune";
  $pl_name1[9] = "Pluto";
  $pl_name1[10] = "Ascendant";
  $pl_name1[11] = "House 2";
  $pl_name1[12] = "House 3";
  $pl_name1[13] = "House 4";
  $pl_name1[14] = "House 5";
  $pl_name1[15] = "House 6";
  $pl_name1[16] = "House 7";
  $pl_name1[17] = "House 8";
  $pl_name1[18] = "House 9";
  $pl_name1[19] = "MC (Midheaven)";
  $pl_name1[20] = "House 11";
  $pl_name1[21] = "House 12";


  for ($xx = 1; $xx <= 2; $xx++)
  {
    //fetch all data for this record
    if ($xx == 1) { $existing_name1 = $birth_data_array[$xx][0]; }
    if ($xx == 2) { $existing_name2 = $birth_data_array[$xx][0]; }

    //assign data from database to local variables
    $secs = "0";
    if ($birth_data_array[$xx][7] < 0)
    {
      $tz = $birth_data_array[$xx][7];
    }
    else
    {
      $tz = "+" . $birth_data_array[$xx][7];
    }

    $tz = -$tz;               //because in AstroWin & Astro123, west longitude is a positive number and time zone is a positive number

    $am_pm = $birth_data_array[$xx][6] . "M ";

    if ($xx == 1)
    {
      $header1 = '<b>Data for ' . strftime("%A, %B %d, %Y at %X $am_pm (time zone = GMT $tz hours)</b><br><br><br>\n", mktime($birth_data_array[$xx][4], $birth_data_array[$xx][5], $secs, $birth_data_array[$xx][1], $birth_data_array[$xx][2], $birth_data_array[$xx][3]));
      $line1 = $existing_name1 . ", born " . strftime("%A, %B %d, %Y at %X $am_pm (time zone = GMT $tz hours)</b>", mktime($birth_data_array[$xx][4], $birth_data_array[$xx][5], $secs, $birth_data_array[$xx][1], $birth_data_array[$xx][2], $birth_data_array[$xx][3]));

      CalculatePositions($xx, $birth_data_array, $longitude, $declination, $house_pos);

      for ($z = 0; $z <= 21; $z++)
      {
        $longitude1[$z] = $longitude[$z];
        $declination1[$z] = $declination[$z];
      }

      for ($z = 0; $z <= 9; $z++)
      {
        $house_pos1[$z] = $house_pos[$z];
      }

      $hob[1] = $birth_data_array[$xx][4];
      $mob[1] = $birth_data_array[$xx][5];
    }
    else
    {
      $header2 = '<b>Data for ' . strftime("%A, %B %d, %Y at %X $am_pm (time zone = GMT $tz hours)</b><br><br><br>\n", mktime($birth_data_array[$xx][4], $birth_data_array[$xx][5], $secs, $birth_data_array[$xx][1], $birth_data_array[$xx][2], $birth_data_array[$xx][3]));
      $line2 = $existing_name2 . ", born " . strftime("%A, %B %d, %Y at %X $am_pm (time zone = GMT $tz hours)</b>", mktime($birth_data_array[$xx][4], $birth_data_array[$xx][5], $secs, $birth_data_array[$xx][1], $birth_data_array[$xx][2], $birth_data_array[$xx][3]));

      // assign data from database into arrays for display
      for ($z = 0; $z <= 21; $z++)
      {
        $pl_name2[$z] = $pl_name1[$z];
      }

      CalculatePositions($xx, $birth_data_array, $longitude, $declination, $house_pos);

      for ($z = 0; $z <= 21; $z++)
      {
        $longitude2[$z] = $longitude[$z];
        $declination2[$z] = $declination[$z];
      }

      for ($z = 0; $z <= 9; $z++)
      {
        $house_pos2[$z] = $house_pos[$z];
      }

      $hob[2] = $birth_data_array[$xx][4];
      $mob[2] = $birth_data_array[$xx][5];
    }
  }

  $num_MRs = GetMutualReceptions($longitude1, $longitude2);
  $dynes = GetCosmodynes($longitude1, $declination1, $house_pos1, $longitude2, $declination2, $house_pos2, $hob, $mob);

  DisplayResults($dynes, $num_MRs);

  echo "<FONT color='#0000ff' SIZE='4' FACE='Arial'><b>For ID #$id[1] --- </b></font>";
  echo "<FONT color='#ff0000' SIZE='5' FACE='Arial'><b>$existing_name1 </b></font><br><br>";
  echo $header1;

  $hr_ob = $hob[1];
  $min_ob = $mob[1];

  $ubt1 = 0;
  if (($hr_ob == 12) And ($min_ob == 0))
  {
    $ubt1 = 1;        // this person has an unknown birth time
  }

  DisplayNatalData($pl_name1, $longitude1, $declination1, $house_pos1, $hr_ob, $min_ob);

  echo "<FONT color='#0000ff' SIZE='4' FACE='Arial'><b>For ID #$id[2] --- </b></font>";
  echo "<FONT color='#ff0000' SIZE='5' FACE='Arial'><b>$existing_name2 </b></font><br><br>";
  echo $header2;

  $hr_ob = $hob[2];
  $min_ob = $mob[2];

  $ubt2 = 0;
  if (($hr_ob == 12) And ($min_ob == 0))
  {
    $ubt2 = 1;        // this person has an unknown birth time
  }

  DisplayNatalData($pl_name2, $longitude2, $declination2, $house_pos2, $hr_ob, $min_ob);

  echo "</center>";

  include("constants_eng.php");     // this is here because we must rename the planet names


//display the synastry report
  if ($no_interps == False)
  {
    require ('calc_dual_dyne_harmony.php');

    $dynes = Get_Dual_Cosmodyne_Harmony($longitude1, $declination1, $house_pos1, $longitude2, $declination2, $house_pos2, $hob, $mob);

    include ('synastry_report.php');
    Generate_synastry_report($existing_name1, $existing_name2, $line1, $line2, $pl_name1, $longitude1, $longitude2, $longitude1[10], $longitude2[10], $ubt1, $ubt2, $dynes);
  }


  include ('footer.html');

  exit();


Function CalculatePositions($last_id, $birth_data_array, &$longitude, &$declination, &$house_pos)
{
  $swephsrc = './sweph';    //sweph MUST be in a folder no less than at this level
  $sweph = './sweph';

  // Unset any variables not initialized elsewhere in the program
  unset($PATH,$out,$pl_name);

  //assign data from database to local variables
  $inmonth = intval($birth_data_array[$last_id][1]);
  $inday = intval($birth_data_array[$last_id][2]);
  $inyear = intval($birth_data_array[$last_id][3]);

  $inhours = intval($birth_data_array[$last_id][4]);
  $inmins = intval($birth_data_array[$last_id][5]);
  $insecs = "0";

  if (strtolower($birth_data_array[$last_id][6]) == "p")
  {
    if ($inhours != 12) { $inhours = $inhours + 12; }
  }
  else
  {
    if ($inhours == 12) { $inhours = $inhours - 12; }
  }

  $intz = intval($birth_data_array[$last_id][7]);

  $long_deg = intval($birth_data_array[$last_id][8]);
  $long_min = intval($birth_data_array[$last_id][9]);

  $lat_deg = intval($birth_data_array[$last_id][10]);
  $lat_min = intval($birth_data_array[$last_id][11]);

  if ($long_deg >= 0)
  {
    $ew_txt = "w";
    $ew = -1;
  }
  else
  {
    $ew_txt = "e";
    $ew = 1;
  }

  if ($lat_deg > 0)
  {
    $ns_txt = "n";
    $ns = 1;
  }
  else
  {
    $ns_txt = "s";
    $ns = -1;
  }

  $intz = -$intz;             //because in AstroWin and Astro123, west longitude is a positive number and time zone is a positive number

  $long_deg = abs($long_deg);
  $lat_deg = abs($lat_deg);


  $my_longitude = $ew * ($long_deg + ($long_min / 60));
  $my_latitude = $ns * ($lat_deg + ($lat_min / 60));

  $abs_tz = abs($intz);
  $the_hours = floor($abs_tz);
  $fraction_of_hour = $abs_tz - floor($abs_tz);
  $the_minutes = 60 * $fraction_of_hour;
  $whole_minutes = floor(60 * $fraction_of_hour);
  $fraction_of_minute = $the_minutes -$whole_minutes;
  $whole_seconds = round(60 * $fraction_of_minute);

  if ($intz >= 0)
  {
    $inhours = $inhours - $the_hours;
    $inmins = $inmins - $whole_minutes;
    $insecs =  $insecs - $whole_seconds;
  }
  else
  {
    $inhours = $inhours + $the_hours;
    $inmins = $inmins + $whole_minutes;
    $insecs =  $insecs + $whole_seconds;
  }

  $utdatenow = strftime("%d.%m.%Y", mktime($inhours, $inmins, $insecs, $inmonth, $inday, $inyear));
  $utnow = strftime("%H:%M:%S", mktime($inhours, $inmins, $insecs, $inmonth, $inday, $inyear));

  putenv("PATH=$PATH:$swephsrc");

  // get 10 planets and all house cusps
  exec ("swetest -edir$sweph -b$utdatenow -ut$utnow -p0123456789 -eswe -house$my_longitude,$my_latitude, -fPldj -g, -head", $out);

  foreach ($out as $key => $line)
  {
    $row = explode(',',$line);
    $pl_name[$key] = $row[0];
    $longitude[$key] = $row[1];
    $declination[$key] = $row[2];
    $house_pos[$key] = $row[3];
  };


  //I want this routine to change the data in the house position array, hence my use of "&$house_pos"
  for ($x = 1; $x <= 12; $x++)
  {
    for ($y = 0; $y <= 9; $y++)
    {
      $pl = $longitude[$y] + (1 / 36000);
      if ($x < 12 And $longitude[$x + 9] > $longitude[$x + 10])
      {
        if (($pl >= $longitude[$x + 9] And $pl < 360) Or ($pl < $longitude[$x + 10] And $pl >= 0))
        {
          $house_pos[$y] = $x;
          continue;
        }
      }

      if ($x == 12 And ($longitude[$x + 9] > $longitude[10]))
      {
        if (($pl >= $longitude[$x + 9] And $pl < 360) Or ($pl < $longitude[10] And $pl >= 0))
        {
          $house_pos[$y] = $x;
        }
        continue;
      }

      if (($pl >= $longitude[$x + 9]) And ($pl < $longitude[$x + 10]) And ($x < 12))
      {
        $house_pos[$y] = $x;
        continue;
      }

      if (($pl >= $longitude[$x + 9]) And ($pl < $longitude[10]) And ($x == 12))
      {
        $house_pos[$y] = $x;
      }
    }
  }
}

?>
