<?php
  session_start();

  include("constants.php");

  //$copyright1 = "This chart wheel is copyrighted";
  //$copyright2 = "and generated at www.astrowin.org";
  $copyright1 = "Copyright 2017 - www.astrowin.org";
  $legend1 = "Transit planets in red, natal in black";

  $line1 = safeEscapeString($_GET["l1"]);
  $line2 = safeEscapeString($_GET["l2"]);

  $retrograde1 = safeEscapeString($_GET["rx1"]);
  $retrograde2 = safeEscapeString($_GET["rx2"]);

  $ubt1 = safeEscapeString($_GET["ubt1"]);
  $ubt2 = safeEscapeString($_GET["ubt2"]);

  if ($ubt1 != 0 And $ubt1 != 1) { $ubt1 = 0; }
  if ($ubt2 != 0 And $ubt2 != 1) { $ubt2 = 0; }

  if (get_magic_quotes_gpc())
  {
    $longitude1 = unserialize(stripslashes($_GET["p1"]));
    $hc1 = unserialize(stripslashes($_GET["hc1"]));
    $house_pos1 = unserialize(stripslashes($_GET["hpos"]));

    $longitude2 = unserialize(stripslashes($_GET["p2"]));
    $hc2 = unserialize(stripslashes($_GET["hc2"]));
    $house_pos2_in_1 = unserialize(stripslashes($_GET["hpos2"]));
  }
  else
  {
    $longitude1 = unserialize($_GET["p1"]);
    $hc1 = unserialize($_GET["hc1"]);
    $house_pos1 = unserialize($_GET["hpos"]);

    $longitude2 = unserialize($_GET["p2"]);
    $hc2 = unserialize($_GET["hc2"]);
    $house_pos2_in_1 = unserialize($_GET["hpos2"]);
  }

  if ($ubt1 == 1)
  {
    for ($i = 1; $i <= 12; $i++)
    {
      $hc1[$i] = ($i - 1) * 30;
    }

    $hc1[13] = 0;
  }

  if ($ubt2 == 1)
  {
    for ($i = 1; $i <= 12; $i++)
    {
      $hc2[$i] = ($i - 1) * 30;
    }

    $hc2[13] = 0;
  }

  $Ascendant1 = $hc1[1];

  $longitude1[LAST_PLANET + 1] = $hc1[1];
  $longitude1[LAST_PLANET + 2] = $hc1[10];

  $longitude2[LAST_PLANET + 1] = $hc2[1];
  $longitude2[LAST_PLANET + 2] = $hc2[10];



//set the content-type
  header("Content-type: image/png");

//create the blank image
  $overall_size = 744;                    //was 800

  $size_of_rect = $overall_size;          //size of rectangle in which to draw the wheel

  $y_top_margin = 20;                      //was 50

  $im = @imagecreatetruecolor($overall_size, $overall_size + $y_top_margin) or die("Cannot initialize new GD image stream");


//specify all the diameters - from most outer to most inner
  $xoff = 20;           //this is the offset to make the circle bigger or smaller

  $circle1 = 460 + $xoff;       //800;
  $circle2 = 420 + $xoff;       //760;                         //was $outer_outer_diameter
  $circle3 = 340 + $xoff;       //680;                         //was $diameter
  $circle4 = 250;                         //was $diameter - ($inner_diameter_offset_2 * 2)
  //$circle5 = 460;                       //was $diameter - ($divide_diameter * 2)

  $radius = 170 + ($xoff / 2);                          //radius of circle drawn (where tic marks are drawn - and house cusp positions

  $radius1 = 300;                         //natal data :  was $radius - $dist_from_diameter1
  $radius2 = 125;                         //dots & lines for house cusp & Asc & MC : was $radius - $inner_diameter_offset
  $radius3 = 148;                         //house numbers
  //$radius3 = 380;                         //not used : was $radius + $outer_diameter_distance
  //$radius4 = 320;                         //transit data : was $radius - ($dist_from_diameter1 + ($inner_diameter_offset_2 / 2))
  //$radius5 = 357;                         //not used : actual house cusp numbers and sign : was ($outer_outer_diameter + $diameter) / 4 - 3
  $radius6 = 190 + ($xoff / 2);                         //where house cusp info is located

  $center_pt_x = $size_of_rect / 2;                      // center of circle, x
  $center_pt_y = $y_top_margin + ($size_of_rect / 2);    // center of circle, y


//specify the colors
  $white = imagecolorallocate($im, 255, 255, 255);
  $white2 = imagecolorallocate($im, 176, 196, 222);
  $red = imagecolorallocate($im, 255, 0, 0);
  $blue = imagecolorallocate($im, 0, 0, 255);
  $magenta = imagecolorallocate($im, 255, 0, 255);
  $yellow = imagecolorallocate($im, 255, 255, 204);
  $yellow2 = imagecolorallocate($im, 255, 255, 0);
  $cyan = imagecolorallocate($im, 0, 255, 255);
  $green = imagecolorallocate($im, 0, 224, 0);
  $light_green = imagecolorallocate($im, 153, 255, 153);
  $another_green = imagecolorallocate($im, 0, 128, 0);
  $gray = imagecolorallocate($im, 153, 153, 153);
  $black = imagecolorallocate($im, 0, 0, 0);
  $lavender = imagecolorallocate($im, 160, 0, 255);
  $orange = imagecolorallocate($im, 255, 128, 64);
  $orange2 = imagecolorallocate($im, 0, 0, 0);
  $light_blue = imagecolorallocate($im, 239, 239, 239);

// specific colors
  $planet_color = $black;   //was $cyan;
  $planet_color_2 = $red;

  $deg_min_color = $black;    //$white;
  $sign_color = $magenta;

  $last_planet_num = 14 + 2;        //add a planet
  $num_planets = $last_planet_num + 1;
  $spacing1 = 4;     // spacing between planet glyphs around wheel - this number is really one more than shown here
  $spacing2 = 5;     // spacing between planet glyphs around wheel - this number is really one more than shown here

// glyphs used for planets - HamburgSymbols.ttf - Sun, Moon - Pluto
  $pl_glyph[0] = 81;
  $pl_glyph[1] = 87;
  $pl_glyph[2] = 69;
  $pl_glyph[3] = 82;
  $pl_glyph[4] = 84;
  $pl_glyph[5] = 89;
  $pl_glyph[6] = 85;
  $pl_glyph[7] = 73;
  $pl_glyph[8] = 79;
  $pl_glyph[9] = 80;
  $pl_glyph[10] = 77;
  $pl_glyph[11] = 96;
  $pl_glyph[12] = 141;
  $pl_glyph[13] = 60;
  $pl_glyph[14] = 109;


// glyphs used for planets - HamburgSymbols.ttf - Aries - Pisces
  $sign_glyph[1] = 97;
  $sign_glyph[2] = 115;
  $sign_glyph[3] = 100;
  $sign_glyph[4] = 102;
  $sign_glyph[5] = 103;
  $sign_glyph[6] = 104;
  $sign_glyph[7] = 106;
  $sign_glyph[8] = 107;
  $sign_glyph[9] = 108;
  $sign_glyph[10] = 122;
  $sign_glyph[11] = 120;
  $sign_glyph[12] = 99;

// ------------------------------------------

//create colored rectangle on blank image
  imagefilledrectangle($im, 0, 0, $size_of_rect, $size_of_rect + $y_top_margin, $white);

//MUST BE HERE - I DO NOT KNOW WHY - MAYBE TO PRIME THE PUMP
  imagettftext($im, 10, 0, 0, 0, $black, 'arial.ttf', " ");

// ------------------------------------------

//draw the outer-outer border of the chartwheel - only needed if you want to draw an area outside the outer circle
  imagefilledellipse($im, $center_pt_x, $center_pt_y, $circle1, $circle1, $light_blue);   //max is +40

//draw the outer-outer circle of the chartwheel
  imagefilledellipse($im, $center_pt_x, $center_pt_y, $circle2, $circle2, $yellow);
  imageellipse($im, $center_pt_x, $center_pt_y, $circle2, $circle2, $black);

//draw the outer circle of the chartwheel
  imagefilledellipse($im, $center_pt_x, $center_pt_y, $circle3, $circle3, $white);
  imageellipse($im, $center_pt_x, $center_pt_y, $circle3, $circle3, $black);

//the above draw in the gray outermost circle, the yellow circle and the two black lines that border the yellow area


//draw the inner circle of the chartwheel - this is the black circle within which the red transit planets are placed
  imageellipse($im, $center_pt_x, $center_pt_y, $circle1, $circle1, $black);

//draw the inner gray circle where the aspect lines are drawn between dots
  imageellipse($im, $center_pt_x, $center_pt_y, $circle4, $circle4, $gray);

// ------------------------------------------

  //data for chart
  imagettftext($im, 8, 0, 10, 20, $black, 'arial.ttf', $line1);
  imagettftext($im, 8, 0, 10, 38, $black, 'arial.ttf', $line2);

  //imagettftext($im, 8, 0, 550, 20, $black, 'arial.ttf', $copyright1);       //was 828
  //imagettftext($im, 8, 0, 550, 33, $black, 'arial.ttf', $copyright2);      //was 841
  imagettftext($im, 8, 0, 560, 33, $black, 'arial.ttf', $copyright1);       //was 828
  imagettftext($im, 8, 0, 560, 46, $black, 'arial.ttf', $legend1);       //was 828

// ------------------------------------------


//draw the horizontal line for the Ascendant
  $x1 = -$radius2 * cos(deg2rad(0));
  $y1 = -$radius2 * sin(deg2rad(0));

  $x2 = -$radius * cos(deg2rad(0));
  $y2 = -$radius * sin(deg2rad(0));

  imageline($im, $x1 + $center_pt_x, $y1 + $center_pt_y, $x2 + $center_pt_x, $y2 + $center_pt_y, $black);

//draw the arrow for the Ascendant
  $x1 = -$radius;
  $y1 = 30 * sin(deg2rad(0));

  $x2 = -($radius - 12);
  $y2 = 12 * sin(deg2rad(-15));
  imageline($im, $x1 + $center_pt_x, $y1 + $center_pt_y, $x2 + $center_pt_x, $y2 + $center_pt_y, $black);

  $y2 = 12 * sin(deg2rad(15));
  imageline($im, $x1 + $center_pt_x, $y1 + $center_pt_y, $x2 + $center_pt_x, $y2 + $center_pt_y, $black);

// ------------------------------------------

// draw in the actual house cusp longitudes and sign
  for ($i = 1; $i <= 12; $i = $i + 1)
  {
    $angle = -($Ascendant1 - $hc1[$i]);

    $sign_pos = floor($hc1[$i] / 30) + 1;
    if ($sign_pos == 1 Or $sign_pos == 5 Or $sign_pos == 9)
    {
      $clr_to_use = $red;
    }
    elseif ($sign_pos == 2 Or $sign_pos == 6 Or $sign_pos == 10)
    {
      $clr_to_use = $another_green;
    }
    elseif ($sign_pos == 3 Or $sign_pos == 7 Or $sign_pos == 11)
    {
      $clr_to_use = $orange;
    }
    elseif ($sign_pos == 4 Or $sign_pos == 8 Or $sign_pos == 12)
    {
      $clr_to_use = $blue;
    }

    //sign glyph
    if ($i == 10 Or $i == 11)
    {
      display_house_cusp($i, $angle, $radius6 - 3, $xy);
    }
    else
    {
      display_house_cusp($i, $angle, $radius6, $xy);
    }
    imagettftext($im, 12, 0, $xy[0] + $center_pt_x, $xy[1] + $center_pt_y, $clr_to_use, 'HamburgSymbols.ttf', chr($sign_glyph[$sign_pos]));


    //house cusp degree
    if ($i == 1 Or $i == 2 Or $i == 3 Or $i == 6)
    {
      display_house_cusp($i, $angle - 4 - 1, $radius6, $xy);
    }
    elseif ($i == 4 Or $i == 5)
    {
      display_house_cusp($i, $angle - 4 - 2, $radius6, $xy);
    }
    elseif ($i == 10 Or $i == 11)
    {
      display_house_cusp($i, $angle + 5 + 2, $radius6 - 3, $xy);
    }
    else
    {
      display_house_cusp($i, $angle + 5 + 1, $radius6, $xy);
    }

    $reduced_pos = Reduce_below_30($hc1[$i]);
    $int_reduced_pos = floor($reduced_pos);

    if ($int_reduced_pos < 10)
    {
      $t = "0" . $int_reduced_pos;
    }
    else
    {
      $t = $int_reduced_pos;
    }

    imagettftext($im, 10, 0, $xy[0] + $center_pt_x, $xy[1] + $center_pt_y, $black, 'arial.ttf', $t . chr(176));


    //house cusp minute
    if ($i >= 1 And $i <= 4)
    {
      display_house_cusp($i, $angle + 4 + 1, $radius6, $xy);
    }
    elseif ($i == 5 Or $i == 6)
    {
      display_house_cusp($i, $angle + 5 + 1, $radius6, $xy);
    }
    elseif ($i == 7)
    {
      display_house_cusp($i, $angle - 4 - 1, $radius6, $xy);
    }
    elseif ($i == 10 Or $i == 11)
    {
      display_house_cusp($i, $angle - 5 - 1, $radius6 - 3, $xy);
    }
    else
    {
      display_house_cusp($i, $angle - 5 - 1, $radius6, $xy);
    }

    $reduced_pos = Reduce_below_30($hc1[$i]);
    $int_reduced_pos = floor(60 * ($reduced_pos - floor($reduced_pos)));
    if ($int_reduced_pos < 10)
    {
      $t = "0" . $int_reduced_pos;
    }
    else
    {
      $t = $int_reduced_pos;
    }
    imagettftext($im, 10, 0, $xy[0] + $center_pt_x, $xy[1] + $center_pt_y, $black, 'arial.ttf', $t . chr(39));
  }

// ------------------------------------------

// draw the lines for the house cusps
  $angle_sum = 0;
  for ($i = 1; $i <= 12; $i = $i + 1)
  {
    $angle = $Ascendant1 - $hc1[$i];
    $x1 = -$radius * cos(deg2rad($angle));
    $y1 = -$radius * sin(deg2rad($angle));

    $x2 = -$radius2 * cos(deg2rad($angle));
    $y2 = -$radius2 * sin(deg2rad($angle));

    if ($i != 1 And $i != 10)
    {
      imageline($im, $x1 + $center_pt_x, $y1 + $center_pt_y, $x2 + $center_pt_x, $y2 + $center_pt_y, $gray);
    }

    //display the house numbers themselves
    $angle_diff = $hc1[$i + 1] - $hc1[$i];
    if ($angle_diff < -180) { $angle_diff = $angle_diff + 360; }

    $angle_to_use = $angle_sum + ($angle_diff / 2);

    display_house_number_new($i, $angle_to_use, $radius3, $xy);

    imagettftext($im, 9, 0, $xy[0] + $center_pt_x, $xy[1] + $center_pt_y, $blue, 'arial.ttf', $i);      //draws house numbers, 1 - 12

    $angle_sum = $angle_sum + $angle_diff;
  }

// ------------------------------------------


// draw the little degree marks around of the wheel
  $spoke_length = 9;
  $minor_spoke_length = 4;

  for ($i = 0; $i <= 359; $i = $i + 1)
  {
    $angle = $i + $Ascendant1;

    $x1 = -$radius * cos(deg2rad($angle));
    $y1 = -$radius * sin(deg2rad($angle));

    if ($i % 5 == 0)
    {
      $x2 = -($radius - $spoke_length) * cos(deg2rad($angle));
      $y2 = -($radius - $spoke_length) * sin(deg2rad($angle));
      imageline($im, $x1 + $center_pt_x, $y1 + $center_pt_y, $x2 + $center_pt_x, $y2 + $center_pt_y, $red);
    }
    else
    {
      $x2 = -($radius - $minor_spoke_length) * cos(deg2rad($angle));
      $y2 = -($radius - $minor_spoke_length) * sin(deg2rad($angle));
      imageline($im, $x1 + $center_pt_x, $y1 + $center_pt_y, $x2 + $center_pt_x, $y2 + $center_pt_y, $black);
    }
  }


// ------------------------------------------

// draw the near-vertical line for the MC
  $angle = $Ascendant1 - $hc1[10];
  $dist_mc_asc = $angle;

  if ($dist_mc_asc < 0)
  {
    $dist_mc_asc = $dist_mc_asc + 360;
  }

  $value = 90 - $dist_mc_asc;
  $angle1 = 65 - $value;
  $angle2 = 65 + $value;

  $x1 = -$radius2 * cos(deg2rad($angle));
  $y1 = -$radius2 * sin(deg2rad($angle));

  $x2 = -$radius * cos(deg2rad($angle));
  $y2 = -$radius * sin(deg2rad($angle));

  imageline($im, $x1 + $center_pt_x, $y1 + $center_pt_y, $x2 + $center_pt_x, $y2 + $center_pt_y, $black);

// draw the arrow for the 10th house cusp (MC)
  $x1 = $x2 + (15 * cos(deg2rad($angle1)));
  $y1 = $y2 + (15 * sin(deg2rad($angle1)));
  imageline($im, $x1 + $center_pt_x, $y1 + $center_pt_y, $x2 + $center_pt_x, $y2 + $center_pt_y, $black);

  $x1 = $x2 - (15 * cos(deg2rad($angle2)));
  $y1 = $y2 + (15 * sin(deg2rad($angle2)));
  imageline($im, $x1 + $center_pt_x, $y1 + $center_pt_y, $x2 + $center_pt_x, $y2 + $center_pt_y, $black);

// ------------------------------------------


// draw the dividing lines between the signs
  for ($i = 0; $i <= 330; $i = $i + 30)
  {
    //$angle = $Ascendant1 - $hc1[$i];
    $angle = $i + sprintf("%.0f", $Ascendant1);

    $x1 = -($circle1 / 2) * cos(deg2rad($angle));
    $y1 = -($circle1 / 2) * sin(deg2rad($angle));

    $x2 = -($circle2 / 2) * cos(deg2rad($angle));
    $y2 = -($circle2 / 2) * sin(deg2rad($angle));

    imageline($im, $x1 + $center_pt_x, $y1 + $center_pt_y, $x2 + $center_pt_x, $y2 + $center_pt_y, $black);
  }


// put signs around chartwheel
  $cw_sign_glyph = 14;
  $ch_sign_glyph = 12;
  $gap_sign_glyph = -44;

  for ($i = 1; $i <= 12; $i++)
  {
    $angle_to_use = deg2rad((($i - 1) * 30) + 15 - $Ascendant1);

    $center_pos_x = -$cw_sign_glyph / 2;
    $center_pos_y = $ch_sign_glyph / 2;

    $offset_pos_x = $center_pos_x * cos($angle_to_use);
    $offset_pos_y = $center_pos_y * sin($angle_to_use);

    $x1 = $center_pos_x + $offset_pos_x + ((-$radius + $gap_sign_glyph) * cos($angle_to_use));
    $y1 = $center_pos_y + $offset_pos_y + (($radius - $gap_sign_glyph) * sin($angle_to_use));

    if ($i == 1 Or $i == 5 Or $i == 9)
    {
      $clr_to_use = $red;
    }
    elseif ($i == 2 Or $i == 6 Or $i == 10)
    {
      $clr_to_use = $another_green;
    }
    elseif ($i == 3 Or $i == 7 Or $i == 11)
    {
      $clr_to_use = $orange;
    }
    elseif ($i == 4 Or $i == 8 Or $i == 12)
    {
      $clr_to_use = $blue;
    }

    drawboldtext($im, 12, 0, $x1 + $center_pt_x, $y1 + $center_pt_y, $clr_to_use, 'HamburgSymbols.ttf', chr($sign_glyph[$i]), 0); //used to be boldness of 1 - last number
  }


// ------------------------------------------
  //before going further I must put both natal and transit data into one large array (of the different types)
  $long_both = array();
  $house_pos_both = array();
  $type_both = array();
  $rx_both = array();

  $num_base_planets = 15;                                    //Sun - Chiron
  $num_planets_both = $num_base_planets * 2;                 //(Sun through Chiron) * 2

  for ($i = 0; $i <= $num_base_planets - 1; $i++)            //fetch natal data first - Sun through Chiron
  {
    $long_both[$i] = $longitude1[$i];
    $house_pos_both[$i] = $house_pos1[$i];
    $type_both[$i] = 0;                   //0 denotes natal planet
    $rx_both[$i] = mid($retrograde1, $i + 1, 1);
  }

  for ($i = 0; $i <= $num_base_planets - 1; $i++)            //fetch transit data next - Sun through Chiron
  {
    $long_both[$num_base_planets + $i] = $longitude2[$i];
    $house_pos_both[$num_base_planets + $i] = $house_pos2_in_1[$i];
    $type_both[$num_base_planets + $i] = 1;                   //1 denotes transit planet
    $rx_both[$num_base_planets + $i] = mid($retrograde2, $i + 1, 1);
  }

// ------------------------------------------


  //put planets in chartwheel - both natal and transit planets go around the circumference of the wheel
  //sort longitudes in descending order from 360 down to 0 (do not include t. PoF or t. Vertex)
  Sort_planets_by_descending_longitude($num_planets_both - 2, $long_both, $type_both, $rx_both, $sort, $sort_pos, $sort_type, $sort_rx);

  //count how many planets are in each house (do not include t. PoF or t. Vertex)
  Count_planets_in_each_house($num_planets_both - 2, $house_pos_both, $type_both, $rx_both, $sort, $sort_pos, $sort_type, $sort_rx, $nopih, $home);

  //find the best planet to start displaying the wheel and reorder the $sort[] array starting with that planet (do not include t. PoF or t. Vertex)
  Find_best_planet_to_start_with($num_planets_both - 2, $house_pos_both, $type_both, $rx_both, $sort, $sort_pos, $sort_type, $sort_rx, $nopih);

  for ($i = 0; $i <= 359; $i++)
  {
    $spot_filled[$i] = 0;
  }

  $house_num = 0;

  //add planet glyphs around circle
  for ($i = $num_planets_both - 2 - 1; $i >= 0; $i--)
  {
    if ($sort_pos[$i] == LAST_PLANET + SE_POF + 1) { continue; }
    if ($sort_pos[$i] == LAST_PLANET + SE_VERTEX + 1) { continue; }

    // $sort() holds longitudes in descending order from 360 down to 0
    // $sort_pos() holds the planet number corresponding to that longitude
    $temp = $house_num;
    $house_num = $house_pos1[$sort_pos[$i]];              // get the house this planet is in

    if ($temp != $house_num)
    {
      // this planet is in a different house than the last one - this planet is the first one in this house, in other words
      $planets_done = 1;
    }

    // get index for this planet as to where it should be in the possible xx different positions around the wheel
    $from_cusp = Crunch($sort[$i] - $hc1[$house_num]);
    $to_next_cusp = Crunch($hc1[$house_num + 1] - $sort[$i]);
    $next_cusp = $hc1[$house_num + 1];

    $angle = $sort[$i];
    $how_many_more_can_fit_in_this_house = floor($to_next_cusp / ($spacing1 + 1));

    if ($nopih[$house_num] - $planets_done > $how_many_more_can_fit_in_this_house)
    {
      //problem - adjust this planet backwards so others can fit
      $angle = Crunch($next_cusp - (($nopih[$house_num] - $planets_done + 1) * ($spacing1 + 1)));
    }

    while (Check_for_overlap($angle, $spot_filled, $spacing1) == True)
    {
      $angle = $angle + 1;
    }

    // mark this position as being filled
    $spot_filled[round($angle)] = 1;
    $spot_filled[Crunch(round($angle) - 1)] = 1;     //allows for a little better separation between Mars and Sun on 3/13/1966 test example

    // take the above index and convert it into an angle
    $planet_angle[$sort_pos[$i]] = $angle;           //needed for aspect lines
    $angle_to_use = Crunch($angle - $Ascendant1);    //needed for placing info on chartwheel
    $our_angle = $angle_to_use;                      //in degrees

    $angle_to_use = deg2rad($angle_to_use);

    // denote that we have done at least one planet in this house (actually count the planets in this house that we have done)
    $planets_done++;

    display_planet_glyph($our_angle, $angle_to_use, $radius1, $xy, 0);
    if ($sort_type[$i] == 0)
    {
      imagettftext($im, 16, 0, $xy[0] + $center_pt_x, $xy[1] + $center_pt_y, $planet_color, 'HamburgSymbols.ttf', chr($pl_glyph[$sort_pos[$i]]));   //natal
    }
    else
    {
      imagettftext($im, 16, 0, $xy[0] + $center_pt_x, $xy[1] + $center_pt_y, $planet_color_2, 'HamburgSymbols.ttf', chr($pl_glyph[$sort_pos[$i] - $num_base_planets])); //transit
    }

    // display degrees of longitude for each planet
    $reduced_pos = Reduce_below_30($sort[$i]);
    $int_reduced_pos = floor($reduced_pos);
    if ($int_reduced_pos < 10)
    {
      $t = "0" . $int_reduced_pos;
    }
    else
    {
      $t = $int_reduced_pos;
    }

    display_planet_glyph($our_angle, $angle_to_use, $radius1 - 20, $xy, 1);
    imagettftext($im, 10, 0, $xy[0] + $center_pt_x, $xy[1] + $center_pt_y, $planet_color, 'arial.ttf', $t . chr(176));

    // display planet sign
    $sign_pos = floor($sort[$i] / 30) + 1;
    display_planet_glyph($our_angle, $angle_to_use, $radius1 - 40, $xy, 2);
    if ($sign_pos == 1 Or $sign_pos == 5 Or $sign_pos == 9)
    {
      $clr_to_use = $red;
    }
    elseif ($sign_pos == 2 Or $sign_pos == 6 Or $sign_pos == 10)
    {
      $clr_to_use = $another_green;
    }
    elseif ($sign_pos == 3 Or $sign_pos == 7 Or $sign_pos == 11)
    {
      $clr_to_use = $orange;
    }
    elseif ($sign_pos == 4 Or $sign_pos == 8 Or $sign_pos == 12)
    {
      $clr_to_use = $blue;
    }
    imagettftext($im, 10, 0, $xy[0] + $center_pt_x, $xy[1] + $center_pt_y, $clr_to_use, 'HamburgSymbols.ttf', chr($sign_glyph[$sign_pos]));

    // display minutes of longitude for each planet
    $int_reduced_pos = floor(60 * ($reduced_pos - floor($reduced_pos)));
    if ($int_reduced_pos < 10)
    {
      $t = "0" . $int_reduced_pos;
    }
    else
    {
      $t = $int_reduced_pos;
    }
    display_planet_glyph($our_angle, $angle_to_use, $radius1 - 60, $xy, 1);
    imagettftext($im, 10, 0, $xy[0] + $center_pt_x, $xy[1] + $center_pt_y, $planet_color, 'arial.ttf', $t . chr(39));

    // display Rx symbol
    if (strtoupper($sort_rx[$i]) == "R")
    {
      display_planet_glyph($our_angle, $angle_to_use, $radius1 + 22, $xy, 3);
      imagettftext($im, 10, 0, $xy[0] + $center_pt_x, $xy[1] + $center_pt_y, $blue, 'HamburgSymbols.ttf', chr(62));     //was $red
    }
  }

// ------------------------------------------

//draw in the aspect lines
  for ($i = SE_SUN; $i <= $num_planets_both - 1; $i++)      //transit planets
  {
    for ($j = SE_SUN; $j <= $num_planets_both - 1; $j++)    //natal planets
    {
      if ($sort_type[$i] == 0 Or $sort_type[$j] == 1) { continue; }
      if ($sort_pos[$i] >= $num_base_planets + SE_TNODE) { continue; }
      if ($sort_pos[$j] >= SE_POF) { continue; }

      $q = 0;
      $da = abs($long_both[$sort_pos[$i]] - $long_both[$sort_pos[$j]]);

      if ($da > 180) { $da = 360 - $da; }

      // set orb - 3 if Sun or Moon, 2 if not Sun or Moon
      $orb = 2;
      if ($sort_pos[$i] == SE_SUN Or $sort_pos[$i] == SE_MOON Or $sort_pos[$j] == SE_SUN Or $sort_pos[$j] == SE_MOON) { $orb = 2; }

      // is there an aspect within orb?
      if ($da <= $orb)
      {
        $q = 1;
        $dax = $da;

      }
      elseif (($da <= (60 + $orb)) And ($da >= (60 - $orb)))
      {
        $q = 6;
        $dax = abs($da - 60);
      }
      elseif (($da <= (90 + $orb)) And ($da >= (90 - $orb)))
      {
        $q = 4;
        $dax = abs($da - 90);

      }
      elseif (($da <= (120 + $orb)) And ($da >= (120 - $orb)))
      {
        $q = 3;
        $dax = abs($da - 120);

      }
      elseif ($da >= (180 - $orb))
      {
        $q = 2;
        $dax = abs(180 - $da);

      }

      if ($q > 0)
      {
        if ($q == 1 Or $q == 3)
        {
          $aspect_color = $green;       //conjunction and trine
        }
        elseif ($q == 6)
        {
          $aspect_color = $green;        //sextile - was $cyan
        }
        elseif ($q == 4)
        {
          $aspect_color = $red;         //square
        }
        elseif ($q == 2)
        {
          $aspect_color = $red;        //opposition - was $blue
        }
        elseif ($q == 5)
        {
          $aspect_color = $blue;        //not calculated
        }

        if ($q != 1)
        {
          //non-conjunctions
          $x1 = -$radius2 * cos(deg2rad($planet_angle[$sort_pos[$i]] - $Ascendant1));
          $y1 = $radius2 * sin(deg2rad($planet_angle[$sort_pos[$i]] - $Ascendant1));
          $x2 = -$radius2 * cos(deg2rad($planet_angle[$sort_pos[$j]] - $Ascendant1));
          $y2 = $radius2 * sin(deg2rad($planet_angle[$sort_pos[$j]] - $Ascendant1));

          imageline($im, $x1 + $center_pt_x, $y1 + $center_pt_y, $x2 + $center_pt_x, $y2 + $center_pt_y, $aspect_color);    //draw the aspect line

          imagefilledellipse($im, $x2 + $center_pt_x, $y2 + $center_pt_y, 6, 6, $planet_color);         //draw the dots
          imagefilledellipse($im, $x1 + $center_pt_x, $y1 + $center_pt_y, 6, 6, $planet_color_2);

          //draw the small natal planet glyphs
          //$x1 = -135 * cos(deg2rad($planet_angle[$sort_pos[$j]] - $Ascendant1));
          //$y1 = 135 * sin(deg2rad($planet_angle[$sort_pos[$j]] - $Ascendant1));
          //imagettftext($im, 10, 0, $x2 + $center_pt_x, $y2 + $center_pt_y, $planet_color, 'HamburgSymbols.ttf', chr($pl_glyph[$sort_pos[$j]]));   //natal

          $our_angle = $planet_angle[$sort_pos[$j]] - $Ascendant1;
          $angle_to_use = deg2rad($our_angle);

          display_planet_glyph($our_angle, $angle_to_use, $radius2, $xy, 4);

          imagettftext($im, 10, 0, $xy[0] + $center_pt_x, $xy[1] + $center_pt_y, $planet_color, 'HamburgSymbols.ttf', chr($pl_glyph[$sort_pos[$j]]));   //natal


          //draw the small transit planet glyphs
          //$x2 = -135 * cos(deg2rad($planet_angle[$sort_pos[$i]] - $Ascendant1));
          //$y2 = 135 * sin(deg2rad($planet_angle[$sort_pos[$i]] - $Ascendant1));
          //imagettftext($im, 10, 0, $x1 + $center_pt_x, $y1 + $center_pt_y, $planet_color_2, 'HamburgSymbols.ttf', chr($pl_glyph[$sort_pos[$i] - $num_base_planets])); //transit

          $our_angle = $planet_angle[$sort_pos[$i]] - $Ascendant1;
          $angle_to_use = deg2rad($our_angle);

          display_planet_glyph($our_angle, $angle_to_use, $radius2, $xy, 4);

          imagettftext($im, 10, 0, $xy[0] + $center_pt_x, $xy[1] + $center_pt_y, $planet_color_2, 'HamburgSymbols.ttf', chr($pl_glyph[$sort_pos[$i] - $num_base_planets])); //transit
        }
      }
    }
  }

// ------------------------------------------

  // draw the image in png format - using imagepng() results in clearer text compared with imagejpeg()
  imagepng($im);
  imagedestroy($im);
  exit();


Function mid($midstring, $midstart, $midlength)
{
  return(substr($midstring, $midstart-1, $midlength));
}


Function Reduce_below_30($longitude)
{
  $lng = $longitude;

  while ($lng >= 30)
  {
    $lng = $lng - 30;
  }

  return $lng;
}


Function safeEscapeString($inp)
{
  if(is_array($inp))
    return array_map(__METHOD__, $inp);

// replace HTML tags '<>' with '[]'
  $temp1 = str_replace("<", "[", $inp);
  $temp2 = str_replace(">", "]", $temp1);

// but keep <br> or <br />
// turn <br> into <br /> so later it will be turned into ""
// using just <br> will add extra blank lines
  $temp1 = str_replace("[br]", "<br />", $temp2);
  $temp2 = str_replace("[br /]", "<br />", $temp1);

  if(!empty($temp2) && is_string($temp2))
  {
    return str_replace(array('\\', "\0", "\n", "\r", "'", '"', "\x1a"), array('\\\\', '\\0', '\\n', '\\r', "\\'", '\\"', '\\Z'), $temp2);
  }

  return $temp2;
}


Function Sort_planets_by_descending_longitude($num_planets, $longitude, $type_both, $rx_both, &$sort, &$sort_pos, &$sort_type, &$sort_rx)
{
// load all $longitude() into sort() and keep track of the planet numbers in $sort_pos()
  for ($i = 0; $i <= $num_planets - 1; $i++)
  {
    $sort[$i] = $longitude[$i];
    $sort_pos[$i] = $i;
    $sort_type[$i] = $type_both[$i];
    $sort_rx[$i] = $rx_both[$i];
  }

// do the actual sort
  for ($i = 0; $i <= $num_planets - 2; $i++)
  {
    for ($j = $i + 1; $j <= $num_planets - 1; $j++)
    {
      if ($sort[$j] > $sort[$i])
      {
        $temp = $sort[$i];
        $temp1 = $sort_pos[$i];
        $temp2 = $sort_type[$i];
        $temp3 = $sort_rx[$i];

        $sort[$i] = $sort[$j];
        $sort_pos[$i] = $sort_pos[$j];
        $sort_type[$i] = $sort_type[$j];
        $sort_rx[$i] = $sort_rx[$j];

        $sort[$j] = $temp;
        $sort_pos[$j] = $temp1;
        $sort_type[$j] = $temp2;
        $sort_rx[$j] = $temp3;
      }
    }
  }
}


Function Count_planets_in_each_house($num_planets, $house_pos, $type_both, $rx_both, &$sort, &$sort_pos, &$sort_type, &$sort_rx, &$nopih, &$home)
{
// reset and count the number of planets in each house
  for ($i = 1; $i <= 12; $i++)
  {
    $nopih[$i] = 0;
  }

// run through all the planets and see how many planets are in each house
  for ($i = 0; $i <= $num_planets - 1; $i++)
  {
    // get house planet is in
    $temp = $house_pos[$sort_pos[$i]];
    $nopih[$temp]++;
    $home[$i] = $temp;
  }

  // now check for Aries planets in same house as Pisces planets that do not start a new house
  while ($home[$num_planets - 1] == $home[0])
  {
    $temp1 = $sort[$num_planets - 1];
    $temp2 = $sort_pos[$num_planets - 1];
    $temp3 = $home[$num_planets - 1];
    $temp4 = $sort_type[$num_planets - 1];
    $temp5 = $sort_rx[$num_planets - 1];

    for ($i = $num_planets - 1; $i >= 1; $i--)
    {
      $sort[$i] = $sort[$i - 1];
      $sort_pos[$i] = $sort_pos[$i - 1];
      $home[$i] = $home[$i - 1];
      $sort_type[$i] = $sort_type[$i - 1];
      $sort_rx[$i] = $sort_rx[$i - 1];
    }

    $sort[0] = $temp1;
    $sort_pos[0] = $temp2;
    $home[0] = $temp3;
    $sort_type[0] = $temp4;
    $sort_rx[0] = $temp5;
  }
}


Function Find_best_planet_to_start_with($num_planets, $house_pos, $type_both, $rx_both, &$sort, &$sort_pos, &$sort_type, &$sort_rx, $nopih)
{
  //step 1 - find planets which have at least 20 deg clearance between themselves and the next lower planet in the array
  for ($i = $num_planets - 2; $i >= 0; $i--)
  {
    if ($sort[$i] - $sort[$i + 1] >= 20)
    {
      //step 2 - is this planet the first (and only) planet in the house?
      $pl_num = $sort_pos[$i];
      $house_of_pl = $house_pos[$pl_num];

      if ($nopih[$house_of_pl] == 1)
      {
        $start_planet = $pl_num;
        $start_planet_idx = $i;
        break;
      }
    }
  }

  if ($i < 0) { return; }       //we did not find a planet that meets our needs so do not change the $sort[] array

  //here we reorder the $sort[] and $sort_pos[] arrays so that we start with the indicated planet, which is $start_planet
  $sp = array();
  $s = array();
  $st = array();
  $sr = array();

  $cnt = $num_planets - 1;
  for ($i = $start_planet_idx; $i >= 0; $i--)
  {
    $sr[$cnt] = $sort_rx[$i];
    $st[$cnt] = $sort_type[$i];
    $sp[$cnt] = $sort_pos[$i];
    $s[$cnt] = $sort[$i];
    $cnt--;
  }

  for ($i = $num_planets - 1; $i > $start_planet_idx; $i--)
  {
    $sr[$cnt] = $sort_rx[$i];
    $st[$cnt] = $sort_type[$i];
    $sp[$cnt] = $sort_pos[$i];
    $s[$cnt] = $sort[$i];
    $cnt--;
  }

  $sort_rx = $sr;
  $sort_type = $st;
  $sort_pos = $sp;
  $sort = $s;
}


Function display_house_number($num, $angle, $radii, &$xy)
{
  if ($num < 10)
  {
    $char_width = 10;
  }
  else
  {
    $char_width = 18;
  }
  $half_char_width = $char_width / 2;
  $char_height = 12;
  $half_char_height = $char_height / 2;

  //puts center of character right on circumference of circle
  $xpos0 = -$half_char_width;
  $ypos0 = $char_height;

  if ($num == 1)
  {
    $x_adj = -cos(deg2rad($angle)) * $half_char_width;
    $y_adj = sin(deg2rad($angle)) * $char_height;
  }
  elseif ($num == 2)
  {
    $x_adj = -cos(deg2rad($angle));// * $char_width;
    $y_adj = sin(deg2rad($angle)) * $char_height;
  }
  elseif ($num == 3)
  {
    $xpos0 = $half_char_width;
    $x_adj = -cos(deg2rad($angle)) * $half_char_width;
    $y_adj = sin(deg2rad($angle)) * $half_char_height;
  }
  elseif ($num == 4)
  {
    $xpos0 = $char_width;
    $x_adj = -cos(deg2rad($angle)) * $half_char_width;
    $ypos0 = $half_char_height;
    $y_adj = sin(deg2rad($angle)) * $half_char_height;
  }
  elseif ($num == 5)
  {
    $xpos0 = $half_char_width;
    $x_adj = -cos(deg2rad($angle)) * $half_char_width;
    $ypos0 = $half_char_height;
    $y_adj = sin(deg2rad($angle)) * $half_char_height;
  }
  elseif ($num == 6)
  {
    $xpos0 = $half_char_width;
    $x_adj = -cos(deg2rad($angle)); // * $half_char_width;
    //$ypos0 = -$half_char_height;
    $y_adj = sin(deg2rad($angle)) * $char_height;
  }
  elseif ($num == 7)
  {
    $x_adj = -cos(deg2rad($angle)) * $char_width;
    $ypos0 = -$half_char_height;
    $y_adj = -sin(deg2rad($angle)) * $char_height;
  }
  elseif ($num == 8)
  {
    $x_adj = -cos(deg2rad($angle)) * $half_char_width;
    $ypos0 = -$half_char_height;
    $y_adj = sin(deg2rad($angle));    // * $half_char_height;
  }
  elseif ($num == 9)
  {
    $xpos0 = -$char_width;
    $x_adj = -cos(deg2rad($angle)) * $char_width;
    $ypos0 = -$half_char_height;
    $y_adj = sin(deg2rad($angle));  // * $half_char_height;
  }
  elseif ($num == 10)
  {
    $xpos0 = -$char_width;
    $x_adj = -cos(deg2rad($angle)) * $char_width;
    $ypos0 = $half_char_height;
    $y_adj = sin(deg2rad($angle)) * $half_char_height;
  }
  elseif ($num == 11)
  {
    $xpos0 = -$half_char_width;
    $x_adj = -cos(deg2rad($angle)) * $half_char_width;
    $y_adj = sin(deg2rad($angle)) * $char_height;
  }
  elseif ($num == 12)
  {
    $x_adj = -cos(deg2rad($angle)) * $half_char_width;
    $y_adj = sin(deg2rad($angle)) * $char_height;
  }

  $xy[0] = $xpos0 + $x_adj - ($radii * cos(deg2rad($angle + 12)));
  $xy[1] = $ypos0 + $y_adj + ($radii * sin(deg2rad($angle + 12)));

  return ($xy);
}


Function drawboldtext($image, $size, $angle, $x_cord, $y_cord, $clr_to_use, $fontfile, $text, $boldness)
{
  $_x = array(1, 0, 1, 0, -1, -1, 1, 0, -1);
  $_y = array(0, -1, -1, 0, 0, -1, 1, 1, 1);

  for ($n = 0; $n <= $boldness; $n++)
  {
    ImageTTFText($image, $size, $angle, $x_cord+$_x[$n], $y_cord+$_y[$n], $clr_to_use, $fontfile, $text);
  }
}


Function display_planet_glyph($our_angle, $angle_to_use, $radii, &$xy, $code)
{
// $code = 0 for planet glyph, 1 for text, 2 for sign glyph, 3 for Rx symbol, 4 for small planet glyphs shown with aspect lines
// $our_angle in degree, $angle_to_use in radians
  $this_angle = Crunch($our_angle);

  if ($this_angle >= 1 And $this_angle <= 181)
  {
    if ($code == 0)
    {
      $cw_pl_glyph = 17;
      $ch_pl_glyph = 17;
    }
    elseif ($code == 1)
    {
      $cw_pl_glyph = 14;
      $ch_pl_glyph = 12;
    }
    elseif ($code == 2)
    {
      $cw_pl_glyph = 14;
      $ch_pl_glyph = 12;
    }
    elseif ($code == 3)
    {
      $cw_pl_glyph = 8;
      $ch_pl_glyph = 10;
    }
    elseif ($code == 4)
    {
      $cw_pl_glyph = 8;
      $ch_pl_glyph = 10;
    }
  }
  else
  {
    if ($code == 0)
    {
      $cw_pl_glyph = 13;
      $ch_pl_glyph = 17;
    }
    elseif ($code == 1)
    {
      $cw_pl_glyph = 8;
      $ch_pl_glyph = 8;
    }
    elseif ($code == 2)
    {
      $cw_pl_glyph = 8;
      $ch_pl_glyph = 8;
    }
    elseif ($code == 3)
    {
      $cw_pl_glyph = 6;
      $ch_pl_glyph = 10;
    }
    elseif ($code == 4)
    {
      $cw_pl_glyph = 6;
      $ch_pl_glyph = 10;
    }
  }

  $gap_pl_glyph = -10;

// take into account the width and height of the glyph, defined below
// get distance we need to shift the glyph so that the absolute middle of the glyph is the start point
  $center_pos_x = -$cw_pl_glyph / 2;
  $center_pos_y = $ch_pl_glyph / 2;

// get the offset we have to move the center point to in order to be properly placed
  $offset_pos_x = $center_pos_x * cos($angle_to_use);
  $offset_pos_y = $center_pos_y * sin($angle_to_use);

// now get the final X, Y coordinates
  $xy[0] = $center_pos_x + $offset_pos_x + ((-$radii + $gap_pl_glyph) * cos($angle_to_use));
  $xy[1] = $center_pos_y + $offset_pos_y + (($radii - $gap_pl_glyph) * sin($angle_to_use));

  return ($xy);
}


Function display_house_cusp($num, $angle, $radii, &$xy)
{
  $char_width = 18 - 2;
  $half_char_width = $char_width / 2;
  $char_height = 12 - 2;
  $half_char_height = $char_height / 2;

//puts center of character right on circumference of circle
  $xpos0 = -$half_char_width;
  $ypos0 = $half_char_height;

  $x_adj = -cos(deg2rad($angle));
  $y_adj = sin(deg2rad($angle));

  $xy[0] = $xpos0 + $x_adj - ($radii * cos(deg2rad($angle)));
  $xy[1] = $ypos0 + $y_adj + ($radii * sin(deg2rad($angle)));

  return ($xy);
}


Function Crunch($x)
{
  if ($x >= 0)
  {
    $y = $x - floor($x / 360) * 360;
  }
  else
  {
    $y = 360 + ($x - ((1 + floor($x / 360)) * 360));
  }

  return $y;
}


Function Check_for_overlap($angle, $spot_filled, $spacing)
{
// spacing is really 1 more than we enter with, but we use assign $spacing = 1 less for easier math below
  $result = False;

  for ($i = $angle - $spacing; $i <= $angle + $spacing; $i++)
  {
    if ($spot_filled[Crunch(round($i))] == 1)
    {
      $result = True;
      break;
    }
  }

  return $result;
}


Function display_house_number_new($num, $angle, $radii, &$xy)
{
  if ($num < 10)
  {
    $char_width = 10;
  }
  else
  {
    $char_width = 18;
  }
  $half_char_width = $char_width / 2;
  $char_height = 12;
  $half_char_height = $char_height / 2;
  $quarter_char_height = $char_height / 4;

//puts center of character right on circumference of imaginary circle
  $xpos0 = -$half_char_width;
  $ypos0 = $char_height;

  if ($num == 1)
  {
    $radii = $radii + 1;

    $x_adj = -cos(deg2rad($angle)) * $half_char_width;
    $ypos0 = $half_char_height - ($half_char_height / 2);
    $y_adj = sin(deg2rad($angle)) * $char_height;
  }
  elseif ($num == 2)
  {
    $radii = $radii + 3;

    $x_adj = -cos(deg2rad($angle));
    $ypos0 = $half_char_height - ($half_char_height / 2);
    $y_adj = sin(deg2rad($angle)) * $char_height;
  }
  elseif ($num == 3)
  {
    $xpos0 = -$half_char_width;
    $x_adj = -cos(deg2rad($angle)) * $half_char_width;
    $ypos0 = $char_height - 4;
    $y_adj = sin(deg2rad($angle)) * $half_char_height;
  }
  elseif ($num == 4)
  {
    $xpos0 = -$half_char_width;
    $x_adj = -cos(deg2rad($angle)) * $half_char_width;
    $ypos0 = $char_height - 2;
    $y_adj = sin(deg2rad($angle)) * $half_char_height;
  }
  elseif ($num == 5)
  {
    $xpos0 = 3;
    $x_adj = -cos(deg2rad($angle)) * $half_char_width;
    $ypos0 = $half_char_height;
    $y_adj = sin(deg2rad($angle)) * $half_char_height;
  }
  elseif ($num == 6)
  {
    $radii = $radii + 5;

    $xpos0 = $half_char_width / 2;
    $x_adj = -cos(deg2rad($angle));
    $ypos0 = $half_char_height;
    //$y_adj = sin(deg2rad($angle)) * $char_height;
  }
  elseif ($num == 7)
  {
    $radii = $radii + 3;

    $x_adj = -cos(deg2rad($angle)) * $char_width;
    $ypos0 = 0;
    $y_adj = -sin(deg2rad($angle)) * $char_height;
  }
  elseif ($num == 8)
  {
    $radii = $radii - 2;

    $xpos0 = $half_char_width;
    $x_adj = -cos(deg2rad($angle));
    $ypos0 = $half_char_height;
    $y_adj = sin(deg2rad($angle)) * $char_height;
  }
  elseif ($num == 9)
  {
    $xpos0 = 0;
    $x_adj = -cos(deg2rad($angle)) * $char_width;
    $ypos0 = 2;
    $y_adj = sin(deg2rad($angle)) * $half_char_height;
  }
  elseif ($num == 10)
  {
    $xpos0 = 0;
    $x_adj = -cos(deg2rad($angle)) * $char_width;
    $ypos0 = 2;
    $y_adj = sin(deg2rad($angle)) * $half_char_height;
  }
  elseif ($num == 11)
  {
    $radii = $radii + 6;

    $xpos0 = 0;
    $x_adj = -cos(deg2rad($angle)) * $half_char_width;
    $y_adj = sin(deg2rad($angle)) * $char_height;
  }
  elseif ($num == 12)
  {
    $radii = $radii + 2;

    $xpos0 = -$half_char_width;
    $x_adj = -cos(deg2rad($angle)) * $half_char_width / 2;
    $ypos0 = $half_char_height;
    $y_adj = sin(deg2rad($angle));
  }

  $xy[0] = $xpos0 + $x_adj - ($radii * cos(deg2rad($angle)));
  $xy[1] = $ypos0 + $y_adj + ($radii * sin(deg2rad($angle)));;

  return ($xy);
}


Function imageline_dashed($image, $x1, $y1, $x2, $y2, $fcolor, $bcolor)
{
  $thick = 1;
  $style = array($fcolor, $fcolor, $fcolor, $bcolor, $bcolor, $bcolor);
  imagesetstyle($image, $style);
  imagesetthickness($image, $thick);

  return imageline($image, $x1, $y1, $x2, $y2, IMG_COLOR_STYLED);
}


Function imageline_dashed_2($image, $x1, $y1, $x2, $y2, $fcolor, $bcolor)
{
  $thick = 1;
  $style = array($fcolor, $fcolor, $fcolor, $fcolor, $fcolor, $fcolor, $fcolor, $bcolor, $bcolor, $bcolor, $bcolor, $bcolor, $bcolor, $bcolor);
  imagesetstyle($image, $style);
  imagesetthickness($image, $thick);

  return imageline($image, $x1, $y1, $x2, $y2, IMG_COLOR_STYLED);
}

?>
